﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="Cache_Management.ascx.cs" Inherits="Scoreboard.WebServices.resources.Controls.CacheManagement" %>

<div>
        <table border="0">
            <tr>
                <td valign="bottom" rowspan="2">&nbsp;</td>
                <td><h1 class="ControlTop">Cache Management</h1></h1></td>
            </tr>
            <tr>
                <td valign="top" align="center">
                <strong><asp:Label ID="lblMessage" runat="server" Text="" CssClass="errorMessage" />&nbsp;</strong>
                </td>
            </tr>
        </table>
        <p>This management utility allows you to visually inspect and compare the values in the NorthStarLive! Scoreboard web services cache versus the values actually stored in the database.
        Last Update and/or Last Cached values that differ significantly indicate stale values. Click the <strong>Clear Cache Data Statistics</strong> button to force the webservices
        to recalculate and reload database statistics values.</p>
        </div>
<div>

<div style="border:dashed 1px #0000ff;padding:10px;">
<h3>Cache Values</h2>
    <asp:Button ID="btnRefreshDataStatistics" Text="Check Cache Data Statistics" CssClass="button" OnClick="btnRefreshDataStatistics_Click" runat="server" />
    <asp:Button ID="btnClearDataStatistics" Text="Clear Cache Data Statistics" CssClass="button" OnClick="btnClearDataStatistics_Click" runat="server" />

    <asp:GridView ID="gvCurrentCache" AutoGenerateColumns="false" runat="server">
    <Columns>
        <asp:BoundField ControlStyle-Width="40%" DataField="DataSourceName" HeaderText="Data Source" />
        <asp:BoundField ControlStyle-Width="20%" DataField="LastValue" HeaderText="Last Cached Value" />
        <asp:BoundField ControlStyle-Width="40%" DataField="LastUpdated" HeaderText="Last Updated" />
    </Columns>
    <EmptyDataTemplate>
    Cache is currently empty.
    </EmptyDataTemplate>
    </asp:GridView>
</div>
<br />
<div style="border:dashed 1px #ff0000;padding:10px;">
<h3>Database Values</h2>
    <asp:SqlDataSource
        ID="sdsDataStatistics" runat="server" ConnectionString="<%$ ConnectionStrings:scoreboard %>"
        SelectCommand="SELECT DataSourceName, LastValue, LastUpdated FROM tblDataStatistics">
    <SelectParameters>
        <asp:Parameter Name="LastUpdate" Type="DateTime" />
    </SelectParameters>    
    </asp:SqlDataSource>
    <asp:GridView ID="gvActualValues" AutoGenerateColumns="false" DataSourceID="sdsDataStatistics" runat="server">
    <Columns>
        <asp:BoundField ControlStyle-Width="40%" DataField="DataSourceName" HeaderText="Data Source" />
        <asp:BoundField ControlStyle-Width="20%" DataField="LastValue" HeaderText="Last Cached Value" />
        <asp:BoundField ControlStyle-Width="40%" DataField="LastUpdated" HeaderText="Last Updated" />
    </Columns>
    <EmptyDataTemplate>
    Database statistics table is currently empty.
    </EmptyDataTemplate>
    </asp:GridView>
</div>
</div>