﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="Contest.ascx.cs" Inherits="Scoreboard.WebServices.resources.Controls.Contests" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="ajaxToolkit" %>
<%@ Register Assembly="System.Web.Extensions, Version=1.0.61025.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35"
    Namespace="System.Web.UI" TagPrefix="asp" %>
    <style type="text/css">
        .TextBoxNameDescription { width: 260px; font-family: Arial, Helvetica; font-size: 8pt;}
        td.ContestLabel { width: 80px; font-weight: bold;}
        td.ContestData { width: 180px; }
        .padTop { padding-top: 20px;}
    </style>
    <script type="text/javascript" language="javascript">
        var newRowCount = 0;
        var addedItems = new Array();

        // Validate the textbox values
        function checkTextboxValue(objectName) {
            objectName = objectName.toString().replace(/\$/g,"_");

            // Set page dirty
            changeTextboxValue(objectName);
            // if the value doesn't validate, then highlight red
            if (!isValidValue(document.getElementById(objectName).value))
                document.getElementById(objectName).style.backgroundColor = "#ff0000";
        }

        // Value validation
        function isValidValue(elementValue) {
            return (!isNumeric(elementValue)) ? false : true;
        }
        
        function copyItem() {
            for (var i = 0; i < pageControls["lbAllItems"].length; i++) {
                if (pageControls["lbAllItems"][i].selected) {

                    // Don't allow duplicate times to be added
                    var isNew = true;
                    for (var j = 0; j < addedItems.length; j++) {
                        if (addedItems[j] == pageControls["lbAllItems"][i].value) {
                            isNew = false;
                            break;
                        }
                    }

                    // If this item isn't already in the list then add it
                    if (isNew) {
                        var contestItemsTable = pageControls["tblContestItems"];

                        // Insert a new row at the top
                        var newRow = contestItemsTable.insertRow(1);
                        newRow.id = '_addRow' + pageControls["lbAllItems"][i].value;
                        // Set the cell contents
                        var c0 = newRow.insertCell(0);
                        var c1 = newRow.insertCell(1);
                        var c2 = newRow.insertCell(2);

                        c0.innerHTML = pageControls["lbAllItems"][i].innerText +
                            "<input type='hidden' name='addContestItemNumber" + pageControls["lbAllItems"][i].value + "' value='1'>";
                        c1.innerHTML = "<input type='text' class='TextBoxCenterSmall' style='background-color:#ffff00;' name='addContestItemPointValue" + pageControls["lbAllItems"][i].value + "' value='1'>";
                        c2.innerHTML = "<button class=\"button\" onclick=\"javascript:removeItem(this)\">X</button>";
                        newRowCount++;
                        addedItems[newRowCount] = pageControls["lbAllItems"][i].value;
                        pageChanged = true;

                    }
                }
            }
        }

        // Loop through the table and remove everything
        function removeAllItems() {
            if (pageControls["tblContestItems"].getElementsByTagName("TR").length > 1) {
                if (confirm('Remove All Contest Items?')) {
                    var allRows = pageControls["tblContestItems"].getElementsByTagName("TR");
                    // start at the bottom and remove
                    for (var i = allRows.length; i > 1; i--) {
                        pageControls["tblContestItems"].deleteRow(i - 1);
                    }
                    addedItems = new Array();
                    newRowCount = 0;
                    pageChanged = true;

                }
            }
        }

        // Remove the clicked row
        function removeItem(src) {
            var oRow = src.parentElement.parentElement;

            var _fieldNameIdx = oRow.id.indexOf("addRow");
            if (_fieldNameIdx == -1)
                _fieldNameIdx = oRow.id.indexOf("curRow");

            itemId = oRow.id.substring(_fieldNameIdx + 6, oRow.id.length);

            var i = 0; 
            while(i< addedItems.length)
            {
                if (addedItems[i] == itemId)
                    addedItems.splice(i, 1);
                else
                    i++;
            }
            pageControls["tblContestItems"].deleteRow(oRow.rowIndex);
            pageChanged = true;
        }
        
        // Confirm contest deletion
        function confirmContestDelete() {
            var selectedContest = pageControls["contestListControl"].selectedIndex;
            var retVal = false;
            if (selectedContest != -1)
                retVal = confirmDelete(pageControls["contestListControl"][selectedContest].innerText);
            return retVal;
        }

        function checkForm() {
            var errMessage = "The following information must be completed:\r\n";
            var retVal = true;

            // Check name
            if (trim(pageControls["txtContestName"].value) == "") {
                retVal = false;
                errMessage += "- You must define a contest name\r\n";
            }
            
            // Check dates
            if (trim(pageControls["txtContestStartDate"].value) != "" && trim(pageControls["txtContestEndDate"].value) != "") {
//                alert('woot' + pageControls["ddlContestStartTime"].selectedValue);
                var startdate = new Date(pageControls["txtContestStartDate"].value + " " + pageControls["ddlContestStartTime"].value);
                var enddate = new Date(pageControls["txtContestEndDate"].value + " " + pageControls["ddlContestEndTime"].value);
                if (startdate >= enddate) {
                    retVal = false;
                    errMessage += "- Contest End date must occur after Start date\r\n";
                }
            }
            else {
                errMessage += "- Valid Start and End Dates\r\n";
                retVal = false;
            }
            
            if (!retVal)
                alert(errMessage);
            return retVal;
        }
    </script>
<div>
        <div>
        <table border="0">
            <tr>
                <td valign="bottom" rowspan="2"><img src="./images/config_contest.png" width="64" height="64" alt="Contest Configuration" class="floatLeft"/></td>
                <td><h1 class="ControlTop">Contest Settings</h1></h1></td>
            </tr>
            <tr>
                <td valign="top" align="center">
                <strong><asp:Label ID="lblContestMessage" runat="server" Text="" CssClass="errorMessage" />&nbsp;</strong>
                </td>
            </tr>
        </table>
        </div>
                    
        <asp:HiddenField ID="hdnContestId" runat="server" />
        
        <!-- Contest List Panel //-->
            <asp:Panel ID="pnlConfiguredContestsControl" Height="12px" runat="server">
                <div style="padding:5px; cursor: pointer; vertical-align: middle; border: 1px dashed #d0d0d0;">
                    <div style="float: left;font-weight:bold;">Contest List</div>
                    <div style="float: right; vertical-align: middle;">
                        <asp:ImageButton ID="Image1" runat="server" ImageUrl="../../images/expand.jpg" AlternateText="(Show Details...)"/>
                    </div>
                </div>
            </asp:Panel>
            <br />
            <asp:Panel ID="pnlConfiguredContests" runat="server" style="width:100%;height:0px;background-color:#d0d0d0;">
                <table border="0" width="100%">
                <tr>
                    <td valign="top"><asp:ListBox ID="lbAllContests" class="TextBoxNameDescription" style="height:110px;width:400px;" runat="server"/></td>
                    <td valign="top">
                    <asp:Button ID="btnGetContest" CssClass="button" style="width:85px;" Text="View" OnClick="btnGetContest_Click" OnClientClick="if (pageControls['contestListControl'].selectedIndex != -1) { checkPageChanged(); } else {return false}" runat="server" />
                    <br />
                    <br /><asp:Button ID="btnAddContest" CssClass="button" style="width:85px;" Text="Add New"  OnClick="btnAddContest_Click" OnClientClick="return checkPageChanged()" runat="server" />
                    <br /><asp:Button ID="btnDeleteListContest" CssClass="button" style="width:85px;" Text="Delete"  OnClick="btnDeleteListContest_Click" OnClientClick="return confirmContestDelete();" runat="server" />
                    </td>
                </tr>
                </table>
            </asp:Panel>
            <ajaxToolkit:CollapsiblePanelExtender ID="cpeContest" runat="Server"
                    TargetControlID="pnlConfiguredContests"
                    ExpandControlID="pnlConfiguredContestsControl"
                    CollapseControlID="pnlConfiguredContestsControl" 
                    Collapsed="False"
                    ImageControlID="Image1"    
                    ExpandedImage="../../images/collapse.jpg"
                    CollapsedImage="../../images/expand.jpg"
                    SuppressPostBack="true" />
                    
            <!-- Selected Contest Panel //-->
            <asp:Panel ID="pnlSelectedContestDetailsControl" Height="12px" runat="server">
                <div style="padding:5px; cursor: pointer; vertical-align: middle; border: 1px dashed #d0d0d0;">
                    <div style="float: left;font-weight:bold;">Contest Details</div>
                    <div style="float: right; vertical-align: middle;">
                        <asp:ImageButton ID="ibtnSelectedContestDetailsExpand" runat="server" ImageUrl="../../images/expand.jpg" AlternateText="(Show Details...)"/>
                    </div>
                </div>
            </asp:Panel>
            <br />
            
            <asp:Panel ID="pnlSelectedContestDetails" enabled="false" runat="server" style="width:100%;height:0px;background-color:#d0d0d0;">
                <table border="0" cellpadding="0" width="100%">
        <tr>
            <td colspan="4">&nbsp;</td>
        </tr>
        <tr>
            <td class="ContestLabel">Name</td>
            <td class="ContestData" colspan="2"><asp:TextBox ID="txtContestName" class="TextBoxNameDescription" onchange="javascript:changeTextboxValue(this.name);" MaxLength="50" runat="server"/></td>
            
            <td rowspan="2" valign="top" align="center">
            <table border="0">
            <tr>
                <td><asp:CheckBox ID="chkContestActive" runat="server"/></td>
                <td class="ContestLabel">Active</td>
            </tr>
            <tr>
                <td><asp:CheckBox ID="chkContestDisplay" runat="server" /></td>
                <td class="ContestLabel">Display</td>
            </tr></table></td>

        </tr>
        <tr>
            <td class="ContestLabel" valign="top">Description</td>
            <td colspan="2"><asp:TextBox ID="txtContestDescription" TextMode="MultiLine" class="TextBoxNameDescription" Height="50" onchange="javascript:changeTextboxValue(this.name);" MaxLength="255" runat="server" /></td>
        </tr>
        <tr>
            <td colspan="4">
            <table border="0">
            <tr>
            <td class="ContestLabel">Start Date</td>
            <td class="ContestData"><asp:TextBox ID="txtContestStartDate" CssClass="TextboxDate" onchange="javascript:changeTextboxValue(this.name);"  runat="server" />
                <asp:ImageButton runat="Server" ID="ibContestStartCalendar" ImageUrl="../../images/Calendar_scheduleHS.png" AlternateText="Click to show calendar" />
                <ajaxToolkit:CalendarExtender ID="cbeStartDate"
                    TargetControlID="txtContestStartDate"
                    PopupButtonID="ibContestStartCalendar"
                    Format="M/d/yyyy"
                    runat="server" />
                <asp:DropDownList ID="ddlContestStartTime" CssClass="TextboxTime" onchange="javascript:changeTextboxValue(this.name);" runat="server" />
            </td>
            <td class="ContestLabel">End Date</td>
            <td class="ContestData"><asp:TextBox ID="txtContestEndDate" CssClass="TextboxDate" onchange="javascript:changeTextboxValue(this.name);" runat="server" />
                <asp:ImageButton runat="Server" ID="ibContestEndCalendar" ImageUrl="../../images/Calendar_scheduleHS.png" AlternateText="Click to show calendar" />
                <ajaxToolkit:CalendarExtender ID="cbeEndDate"
                    TargetControlID="txtContestEndDate"
                    PopupButtonID="ibContestEndCalendar"
                    Format="M/d/yyyy"
                    runat="server" />
                <asp:DropDownList ID="ddlContestEndTime" CssClass="TextboxTime" onchange="javascript:changeTextboxValue(this.name);" runat="server" />
            </td>
            </tr></table></td>
        </tr>
        <tr>
            <td colspan="4">
                <table border="0" width="100%">
                <tr>
                    <td class="ContestLabel">All Items</td>
                    <td class="ContestLabel">&nbsp;</td>
                    <td class="ContestLabel">Contest Items</td>
                </tr>
                <tr>
                    <td width="45%" valign="top">
                    <asp:ListBox ID="lbAllItems" class="TextBoxNameDescription" SelectionMode="Multiple" style="height:210px;width:200px;" runat="server"/>
                    <ajaxToolkit:ListSearchExtender ID="lseAllItems" runat="server"
                        TargetControlID="lbAllItems" PromptCssClass="listSearch"
                        PromptPosition="Bottom"
                        QueryPattern="Contains" QueryTimeout="2000"/></td>
                    
                    <td width="10%">
                    <input type="button" id="btnAddItem" value="&gt;&gt;" onclick="javascript:copyItem()" /></td>
                    <td width="45%" valign="top">
                    <asp:Table ID="tblContestItems" Width="100%" BorderStyle="Solid" BorderWidth="1" runat="server">
                    <asp:TableHeaderRow>
                        <asp:TableHeaderCell Text="Item" CssClass="ContestLabel" />
                        <asp:TableHeaderCell Text="Points" CssClass="ContestLabel" />
                        <asp:TableHeaderCell><button onclick="javascript:removeAllItems();" class="button">X</button></asp:TableHeaderCell>
                    </asp:TableHeaderRow>
                    </asp:Table>
                </tr>
                </table>
            </td>
        </tr>
        <tr>
            <td colspan="4" align="right">
            <asp:Button ID="btnDeleteContest" Text="Delete" Enabled="false" class="button" runat="server" OnClick="btnDeleteContest_Click" OnClientClick="return confirmContestDelete()"/>
            <asp:Button ID="btnRefreshContest" Text="Refresh" Enabled="false" class="button" OnClick="btnRefreshContest_Click" OnClientClick="return checkPageChanged()"  runat="server"/>
            <asp:Button ID="btnSaveContest" Text="Save" Enabled="false" class="button" OnClick="btnSaveContest_Click" OnClientClick="return checkForm()" runat="server" />
            </td>
        </tr>
        <tr>
        <td width="25%">&nbsp;</td>
        <td width="25%">&nbsp;</td>
        <td width="25%">&nbsp;</td>
        <td width="25%">&nbsp;</td>
        </tr>
        </table>
            </asp:Panel>
            <ajaxToolkit:CollapsiblePanelExtender ID="cpeContestDetail" runat="Server"
                    TargetControlID="pnlSelectedContestDetails"
                    ExpandControlID="pnlSelectedContestDetailsControl"
                    CollapseControlID="pnlSelectedContestDetailsControl" 
                    Collapsed="True"
                    ImageControlID="ibtnSelectedContestDetailsExpand"    
                    ExpandedImage="../../images/collapse.jpg"
                    CollapsedImage="../../images/expand.jpg"
                    SuppressPostBack="true" />

</div>
