﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="Forecast.ascx.cs" Inherits="Scoreboard.WebServices.resources.Controls.Forecast"%>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="ajaxToolkit" %>
<script>

    var maxMoneyValue = 1000000;
    
    function checkPageIsDirty(hostURL, currentDate, inputObject) {
        // If there are changes on the page, then redirect. Otherwise cancel
        if (checkPageChanged())
            self.location = hostURL + '?page=Forecast&weekending=' + inputObject.value;
        else {
            // If there are unsaved changes and the user clicked cancel, then
            // reset the value of the week ending drop down box
            for (var i = 0; i < inputObject.length; i++) {
                if (inputObject.options[i].value == currentDate) {
                    inputObject.selectedIndex = i;
                    break;
                }
            }
            return false;
        }
    }

    // Validate the textbox values
    function checkTextboxValue(objectName) {
        // Set page dirty
        changeTextboxValue(objectName);

        // if the value doesn't validate, then highlight red
        if (!isValidValue(document.getElementById(objectName).value))
            document.getElementById(objectName).style.backgroundColor = "#ff0000";

        document.getElementById(objectName).value = document.getElementById(objectName).value.replace(/^0+/g, "");

    }

    // Value validation
    function isValidValue(elementValue) {
        return (!isMoney(elementValue) || elementValue >= maxMoneyValue) ? false : true;
    }

    // Validate the form.22
    function checkForm() {
        var retVal = true;
        var formElements = theForm.elements;
        for (var i = 0; i < formElements.length; i++) {
            // if this is a textForecast field and it doesn't end with a "1"
            if (formElements[i].name.indexOf("txtForecast") > 0 && formElements[i].name.substring(formElements[i].name.length-1)!="1") {
                var numberVal = document.getElementById(formElements[i].name);
                
                // Ensure that all txtForecast values have money values and >= 1000000 (data limitation).
                // Otherwise, highlight and return false. Check all form elements
                if (!isValidValue(numberVal.value)) {
                    numberVal.style.backgroundColor = "#ff0000";
                    retVal = false;
                }
            }
        }
        
        // If invalid input, then display a message
        if (!retVal)
            alert('Invalid values found. Please correct your input.');
        return retVal;
    }
</script>
    <div>
        <div style="width:100%;">
            <table border="0">
            <tr>
                <td valign="bottom" rowspan="2"><img src="./images/config_forecast.png" width="64" height="64" alt="Forecast Configuration" class="floatLeft"/></td>
                <td><h1 class="ControlTop">Forecast/Projection Settings</h1></td>
            </tr>
            <tr>
                <td valign="top" align="center">
                <strong><asp:Label ID="lblForecastMessage" runat="server" Text="" CssClass="errorMessage" />&nbsp;</strong>
                </td>
            </tr>
            </table>
            
            <div style="padding-bottom:20px;">
            <br />
            <strong>Week Ending</strong> <asp:DropDownList ID="ddlWeekSelect" runat="server" />
            </div>

            <asp:Table ID="tblForecastSettings" runat="server" Width="100%" 
                onprerender="tblForecastSettings_PreRender">
                <asp:TableHeaderRow>
                    <asp:TableHeaderCell Text="Weekday">
                    </asp:TableHeaderCell>
                    <asp:TableHeaderCell Text="Daily Sales">
                    </asp:TableHeaderCell>
                    <asp:TableHeaderCell Text="Guest Count">
                    </asp:TableHeaderCell>
                    <asp:TableHeaderCell Text="Labor">
                    </asp:TableHeaderCell>
                </asp:TableHeaderRow>
                <asp:TableRow>
                    <asp:TableCell ID="tcForecast11" Text="" />
                    <asp:TableCell ID="tcForecast12" Text="">
                        <asp:Textbox ID="txtForecast12" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast13" Text="">
                        <asp:Textbox ID="txtForecast13" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast14" Text="">
                        <asp:Textbox ID="txtForecast14" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                </asp:TableRow>
                <asp:TableRow>
                    <asp:TableCell ID="tcForecast21" Text=""/>
                    <asp:TableCell ID="tcForecast22" Text="">
                        <asp:Textbox ID="txtForecast22" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast23" Text="">
                        <asp:Textbox ID="txtForecast23" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast24" Text="">
                        <asp:Textbox ID="txtForecast24" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                </asp:TableRow>
                <asp:TableRow>
                    <asp:TableCell ID="tcForecast31" Text=""/>
                    <asp:TableCell ID="tcForecast32" Text="">
                        <asp:Textbox ID="txtForecast32" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast33" Text="">
                        <asp:Textbox ID="txtForecast33" runat="server" Text="0" Width="100px" class="TextboxNumeric"/></asp:TableCell>
                    <asp:TableCell ID="tcForecast34" Text="">
                        <asp:Textbox ID="txtForecast34" runat="server" Text="0" Width="100px" class="TextboxNumeric"/></asp:TableCell>
                </asp:TableRow>
                <asp:TableRow>
                    <asp:TableCell ID="tcForecast41" Text="" />
                    <asp:TableCell ID="tcForecast42" Text="">
                        <asp:Textbox ID="txtForecast42" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast43" Text="">
                        <asp:Textbox ID="txtForecast43" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast44" Text="">
                        <asp:Textbox ID="txtForecast44" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                </asp:TableRow>
                <asp:TableRow>
                    <asp:TableCell ID="tcForecast51" Text=""/>
                    <asp:TableCell ID="tcForecast52" Text="">
                        <asp:Textbox ID="txtForecast52" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast53" Text="">
                        <asp:Textbox ID="txtForecast53" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast54" Text="">
                        <asp:Textbox ID="txtForecast54" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                </asp:TableRow>
                <asp:TableRow>
                    <asp:TableCell ID="tcForecast61" Text="" />
                    <asp:TableCell ID="tcForecast62" Text="">
                        <asp:Textbox ID="txtForecast62" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast63" Text="">
                        <asp:Textbox ID="txtForecast63" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast64" Text="">
                        <asp:Textbox ID="txtForecast64" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                </asp:TableRow>
                <asp:TableRow>
                    <asp:TableCell ID="tcForecast71" Text="" />
                    <asp:TableCell ID="tcForecast72" Text="">
                        <asp:Textbox ID="txtForecast72" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast73" Text="">
                        <asp:Textbox ID="txtForecast73" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                    <asp:TableCell ID="tcForecast74" Text="">
                        <asp:Textbox ID="txtForecast74" runat="server" Text="0" Width="100px" class="TextboxNumeric"/>
                    </asp:TableCell>
                </asp:TableRow>
                <asp:TableFooterRow>
                    <asp:TableCell ColumnSpan="4">
                        <asp:Button ID="btnCopyLastWeek" OnClick="btnCopyLastWeek_Click" Text="Copy Previous Week" class="button floatLeft" OnClientClick="return checkPageChanged()" runat="server"/>
                        <asp:Button ID="btnSaveForecast" OnClick="btnSaveForecast_Click" Text="Save" OnClientClick="return checkForm()" class="button floatRight" runat="server"/>
                        <asp:Button ID="btnRefreshForecast" OnClick="btnRefresh_Click" OnClientClick="return checkPageChanged()" Text="Reload This Week" class="button floatRight" runat="server"/>
                    </asp:TableCell>
                </asp:TableFooterRow>
            </asp:Table>
            <asp:HiddenField ID="txtForecast11" runat="server" />
            <asp:HiddenField ID="txtForecast21" runat="server" />
            <asp:HiddenField ID="txtForecast31" runat="server" />
            <asp:HiddenField ID="txtForecast41" runat="server" />
            <asp:HiddenField ID="txtForecast51" runat="server" />
            <asp:HiddenField ID="txtForecast61" runat="server" />
            <asp:HiddenField ID="txtForecast71" runat="server" />

        </div>
    </div>
