USE NorthStarLive
GO

/*
Make sure that TUAU is disabled
*/
UPDATE tblSQLImportTasks SET Enabled = 0 WHERE Title='Tell Us About Us'

/*
Make sure that the Purge Times are set correctly
*/
UPDATE tblSQLImportTasks SET PurgeTimeOfDay = '1/1/2010 03:59:00'
UPDATE tblXMLImportTasks SET PurgeTimeOfDay = '1/1/2010 03:59:00'
UPDATE tblWebServiceImportTasks SET PurgeTimeOfDay = '1/1/2010 03:59:00'
GO

/*
REMOVE Bar KDS Exclusion
*/
ALTER Procedure spGetDailyTicketTimes
(
    @dtCalendar as datetime = null
)
As
BEGIN
	set nocount on

	SELECT
	    TicketTimeAvg,
	    TotalCount,
	    StationName,
	    Last15Min,
	    Duration,
	    ItemCount,
	    ExpectedCookTime
	FROM tblCurrentKitchenTimes
	--	WHERE StationName NOT LIKE 'bar%'
	ORDER BY StationName

	return @@rowcount
	set nocount off
END
GO
